#pragma once

#include <vector>

class XResourceManager : public IResourceManager
{
	std::vector <ITexture*>			m_arTextures;
	std::vector <IMesh*>			m_arMeshes;
	std::vector <IVertexBuffer*>	m_arVB;
	std::vector <IIndexBuffer*>		m_arIB;
	std::vector <ID3DXSprite*>		m_arSprites;
	std::vector <I3DFont*>			m_arFonts;
	
	DWORD m_dwRef;
	
public:	
	virtual HRESULT	AddTexture(ITexture * pTextureToAdd);
	virtual HRESULT	AddMesh(IMesh * pMeshToAdd);
	virtual HRESULT	AddVertexBuffer(IVertexBuffer * pBufferToAdd);
	virtual HRESULT	AddIndexBuffer(IIndexBuffer * pBufferToAdd);
	virtual HRESULT	AddFont(I3DFont * pFontToAdd);
	virtual HRESULT	AddSprite(ID3DXSprite * pSpriteToAdd);
	
	virtual HRESULT	ReleaseAll();
	virtual HRESULT	RestoreAll();
	
	virtual HRESULT		AddRef();
	virtual HRESULT		Release();
public:
	XResourceManager(void);
	~XResourceManager(void);
};
